/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../../common";

export declare namespace OspDataTypes {
  export type ContentStructStruct = {
    contentType: PromiseOrValue<BigNumberish>;
    communityId: PromiseOrValue<BigNumberish>;
    referencedProfileId: PromiseOrValue<BigNumberish>;
    referencedContentId: PromiseOrValue<BigNumberish>;
    contentURI: PromiseOrValue<string>;
    referenceModule: PromiseOrValue<string>;
    collectModule: PromiseOrValue<string>;
    collectNFT: PromiseOrValue<string>;
  };

  export type ContentStructStructOutput = [
    number,
    BigNumber,
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    string
  ] & {
    contentType: number;
    communityId: BigNumber;
    referencedProfileId: BigNumber;
    referencedContentId: BigNumber;
    contentURI: string;
    referenceModule: string;
    collectModule: string;
    collectNFT: string;
  };

  export type PostDataStruct = {
    profileId: PromiseOrValue<BigNumberish>;
    communityId: PromiseOrValue<BigNumberish>;
    contentURI: PromiseOrValue<string>;
    collectModule: PromiseOrValue<string>;
    collectModuleInitData: PromiseOrValue<BytesLike>;
    referenceModule: PromiseOrValue<string>;
    referenceModuleInitData: PromiseOrValue<BytesLike>;
  };

  export type PostDataStructOutput = [
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    string,
    string
  ] & {
    profileId: BigNumber;
    communityId: BigNumber;
    contentURI: string;
    collectModule: string;
    collectModuleInitData: string;
    referenceModule: string;
    referenceModuleInitData: string;
  };

  export type EIP712SignatureStruct = {
    v: PromiseOrValue<BigNumberish>;
    r: PromiseOrValue<BytesLike>;
    s: PromiseOrValue<BytesLike>;
    deadline: PromiseOrValue<BigNumberish>;
  };

  export type EIP712SignatureStructOutput = [
    number,
    string,
    string,
    BigNumber
  ] & { v: number; r: string; s: string; deadline: BigNumber };

  export type PostWithSigDataStruct = {
    profileId: PromiseOrValue<BigNumberish>;
    communityId: PromiseOrValue<BigNumberish>;
    contentURI: PromiseOrValue<string>;
    collectModule: PromiseOrValue<string>;
    collectModuleInitData: PromiseOrValue<BytesLike>;
    referenceModule: PromiseOrValue<string>;
    referenceModuleInitData: PromiseOrValue<BytesLike>;
    sig: OspDataTypes.EIP712SignatureStruct;
  };

  export type PostWithSigDataStructOutput = [
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    string,
    string,
    OspDataTypes.EIP712SignatureStructOutput
  ] & {
    profileId: BigNumber;
    communityId: BigNumber;
    contentURI: string;
    collectModule: string;
    collectModuleInitData: string;
    referenceModule: string;
    referenceModuleInitData: string;
    sig: OspDataTypes.EIP712SignatureStructOutput;
  };
}

export interface IPublicationLogicInterface extends utils.Interface {
  functions: {
    "getCollectModule(uint256,uint256)": FunctionFragment;
    "getCollectNFT(uint256,uint256)": FunctionFragment;
    "getContent(uint256,uint256)": FunctionFragment;
    "getContentCount(uint256)": FunctionFragment;
    "getContentPointer(uint256,uint256)": FunctionFragment;
    "getContentType(uint256,uint256)": FunctionFragment;
    "getContentURI(uint256,uint256)": FunctionFragment;
    "getReferenceModule(uint256,uint256)": FunctionFragment;
    "post((uint256,uint256,string,address,bytes,address,bytes))": FunctionFragment;
    "postWithSig((uint256,uint256,string,address,bytes,address,bytes,(uint8,bytes32,bytes32,uint256)))": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "getCollectModule"
      | "getCollectNFT"
      | "getContent"
      | "getContentCount"
      | "getContentPointer"
      | "getContentType"
      | "getContentURI"
      | "getReferenceModule"
      | "post"
      | "postWithSig"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "getCollectModule",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getCollectNFT",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getContent",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getContentCount",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getContentPointer",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getContentType",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getContentURI",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "getReferenceModule",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "post",
    values: [OspDataTypes.PostDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "postWithSig",
    values: [OspDataTypes.PostWithSigDataStruct]
  ): string;

  decodeFunctionResult(
    functionFragment: "getCollectModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getCollectNFT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "getContent", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getContentCount",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getContentPointer",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getContentType",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getContentURI",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getReferenceModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "post", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "postWithSig",
    data: BytesLike
  ): Result;

  events: {};
}

export interface IPublicationLogic extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: IPublicationLogicInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    getCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    getCollectNFT(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    getContent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[OspDataTypes.ContentStructStructOutput]>;

    getContentCount(
      profileId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    getContentPointer(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[BigNumber, BigNumber]>;

    getContentType(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[number]>;

    getContentURI(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    getReferenceModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    post(
      vars: OspDataTypes.PostDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    postWithSig(
      vars: OspDataTypes.PostWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  getCollectModule(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  getCollectNFT(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  getContent(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<OspDataTypes.ContentStructStructOutput>;

  getContentCount(
    profileId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  getContentPointer(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<[BigNumber, BigNumber]>;

  getContentType(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<number>;

  getContentURI(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  getReferenceModule(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  post(
    vars: OspDataTypes.PostDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  postWithSig(
    vars: OspDataTypes.PostWithSigDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    getCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    getCollectNFT(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    getContent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<OspDataTypes.ContentStructStructOutput>;

    getContentCount(
      profileId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContentPointer(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[BigNumber, BigNumber]>;

    getContentType(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<number>;

    getContentURI(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    getReferenceModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    post(
      vars: OspDataTypes.PostDataStruct,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    postWithSig(
      vars: OspDataTypes.PostWithSigDataStruct,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  filters: {};

  estimateGas: {
    getCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getCollectNFT(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContentCount(
      profileId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContentPointer(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContentType(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getContentURI(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getReferenceModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    post(
      vars: OspDataTypes.PostDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    postWithSig(
      vars: OspDataTypes.PostWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    getCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getCollectNFT(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getContent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getContentCount(
      profileId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getContentPointer(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getContentType(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getContentURI(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getReferenceModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    post(
      vars: OspDataTypes.PostDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    postWithSig(
      vars: OspDataTypes.PostWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
